<template>
  <div class="user-management-container">
    <vab-query-form>
      <vab-query-form-left-panel :span="5">
        <el-button icon="el-icon-plus" type="primary" @click="handleEdit($event)">添加</el-button>
        <el-button icon="el-icon-delete" type="danger" @click="handleDelete($event)">删除</el-button>
      </vab-query-form-left-panel>
      <vab-query-form-right-panel :span="19">
        <el-form :inline="true" :model="queryForm" @submit.native.prevent>
          <el-form-item label="字典名称" prop="dictName">
            <el-input v-model.trim="queryForm.dictName" clearable placeholder="请输入字典名称" />
          </el-form-item>
          <el-form-item label="字典类型" prop="dictType">
            <el-input v-model.trim="queryForm.dictType" clearable placeholder="请输入字典类型" />
          </el-form-item>
          <el-form-item label="字典状态" prop="status">
            <el-select v-model="queryForm.status" clearable placeholder="字典状态">
              <el-option label="正常" value="10" />
              <el-option label="停用" value="20" />
            </el-select>
          </el-form-item>
          <el-form-item>
            <el-button icon="el-icon-search" type="primary" @click="queryData">查询</el-button>
          </el-form-item>
        </el-form>
      </vab-query-form-right-panel>
    </vab-query-form>

    <el-table v-loading="listLoading" border :data="list" :height="height" @selection-change="setSelectRows">
      <el-table-column align="center" show-overflow-tooltip type="selection" />
      <el-table-column align="center" label="id" prop="id" show-overflow-tooltip />
      <el-table-column align="center" label="字典名称" prop="dictName" show-overflow-tooltip />
      <el-table-column align="center" label="字典类型" :show-overflow-tooltip="true">
        <template slot-scope="scope">
          <router-link class="link-type" :to="'/system/dict-data/' + scope.row.id">
            <span>{{ scope.row.dictType }}</span>
          </router-link>
        </template>
      </el-table-column>
      <el-table-column align="center" label="状态" prop="status">
        <template #default="{ row }">
          {{ row.status === '10' ? '正常' : '停用' }}
        </template>
      </el-table-column>
      <el-table-column align="center" label="备注" prop="remark" show-overflow-tooltip />
      <el-table-column align="center" label="创建时间" prop="createdTime">
        <template #default="scope">
          <span>{{ parseTime(scope.row.createdTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column align="center" label="操作" show-overflow-tooltip width="85">
        <template #default="{ row }">
          <el-button type="text" @click="handleEdit(row)">编辑</el-button>
          <el-button type="text" @click="handleDelete(row)">删除</el-button>
        </template>
      </el-table-column>
      <template #empty>
        <el-image class="vab-data-empty" :src="require('@/assets/empty_images/data_empty.png')" />
      </template>
    </el-table>
    <el-pagination
      background
      :current-page="queryForm.pageNum"
      :layout="layout"
      :page-size="queryForm.pageSize"
      :total="total"
      @current-change="handleCurrentChange"
      @size-change="handleSizeChange" />
    <edit ref="edit" @fetch-data="fetchData" />
  </div>
</template>

<script>
  import dictApi from '@/api/system/dict'
  import Edit from './components/TypeEdit'

  export default {
    name: 'Dict',
    components: { Edit },
    data() {
      return {
        list: [],
        listLoading: true,
        layout: 'total, sizes, prev, pager, next, jumper',
        total: 0,
        selectRows: '',
        queryForm: {
          pageNum: 1,
          pageSize: 10,
          dictName: undefined,
          dictType: undefined,
          status: undefined,
        },
      }
    },
    computed: {
      height() {
        return this.$baseTableHeight(1)
      },
    },
    created() {
      this.fetchData()
    },
    methods: {
      setSelectRows(val) {
        this.selectRows = val
      },
      handleEdit(row) {
        if (row.id) {
          this.$refs['edit'].showEdit(row)
        } else {
          this.$refs['edit'].showEdit()
        }
      },
      handleDelete(row) {
        if (row.id) {
          this.$baseConfirm('你确定要删除当前项吗', null, async () => {
            const { msg } = await dictApi.deleteDictTypeByIds({ ids: [row.id] })
            this.$baseMessage(msg, 'success', 'vab-hey-message-success')
            await this.fetchData()
          })
        } else {
          if (this.selectRows.length > 0) {
            const ids = this.selectRows.map((item) => item.id).join()
            this.$baseConfirm('你确定要删除选中项吗', null, async () => {
              const { msg } = await dictApi.deleteDictTypeByIds({ ids })
              this.$baseMessage(msg, 'success', 'vab-hey-message-success')
              await this.fetchData()
            })
          } else {
            this.$baseMessage('未选中任何行', 'error', 'vab-hey-message-error')
          }
        }
      },
      handleSizeChange(val) {
        this.queryForm.pageSize = val
        this.fetchData()
      },
      handleCurrentChange(val) {
        this.queryForm.pageNum = val
        this.fetchData()
      },
      queryData() {
        this.queryForm.pageNum = 1
        this.fetchData()
      },
      async fetchData() {
        this.listLoading = true
        const {
          data: { list, total },
        } = await dictApi.getDictTypeList(this.queryForm)
        this.list = list
        this.total = total
        this.listLoading = false
      },
    },
  }
</script>
